--IF RUNNING THIS SCRIPT IN SQL MGMT STUDIO
--1. FROM QUERY MENU, SELECT SQLCMD Mode
--2. UNCOMMENT LINE BELOW AND REPLACE "EN" WITH APPROPRIATE LANGUAGE CODE 
--:setvar languagecode "EN"

declare 
  @v_grid_name VARCHAR(6),
  @v_grid_id NUMERIC(14, 0),
  @v_field_id NUMERIC(14, 0),
  @v_field_id_list VARCHAR(1000),
  @v_grid_key_fields VARCHAR(200),
  @v_dataspy_id NUMERIC(14, 0),
  @sChk nvarchar(1);

-------------------------------------------------------------------------------
-- Set custom grid name
-------------------------------------------------------------------------------

set @v_grid_name = 'WUDFLT'; 

-------------------------------------------------------------------------------
-- Cleanup existing grid
-------------------------------------------------------------------------------
IF EXISTS (SELECT BOT_FUNCTION FROM r5boilertexts WHERE BOT_FUNCTION = @v_grid_name)
BEGIN
      DELETE FROM r5boilertexts where BOT_FUNCTION = @v_grid_name
END

IF EXISTS (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
BEGIN
	DELETE FROM r5queryfield where DQF_DDSPYID in (select DDS_DDSPYID from R5dddataspy where DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name))
	DELETE FROM R5USEGRIDSYSDEFAULT WHERE USD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM R5dddataspy WHERE DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridfield where GFD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridparam where gdp_gridid in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)	
	DELETE FROM r5grid WHERE GRD_GRIDNAME = @v_grid_name
END

IF EXISTS (SELECT FUN_CODE FROM r5functions WHERE FUN_CODE = @v_grid_name)
BEGIN
	DELETE FROM R5EXTMENULANG WHERE EML_EXTMENU IN (SELECT EMN_CODE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name);
	DELETE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name;
	DELETE FROM r5functions where FUN_CODE = @v_grid_name;
END

-------------------------------------------------------------------------------
--Insert r5functions
-------------------------------------------------------------------------------
INSERT INTO R5FUNCTIONS (FUN_CODE,FUN_DESC,FUN_CLASS,FUN_SUBTYPE,FUN_FILE,FUN_PUBLIC,FUN_SELECT,FUN_BACKGROUND,FUN_DIRSEL,FUN_SYSTEM,FUN_DISPLAYAP,FUN_DISPLAYFT,FUN_POPUPAP,FUN_POPUPFT,FUN_DESCCHANGED,FUN_CLASS_ORG,FUN_LST,FUN_RS,FUN_HDR,FUN_EWSREPORT,FUN_PRDDATASRC,FUN_EWSURLNEW,FUN_REPDISABLED,FUN_ADVREPT,FUN_MEKEY,FUN_EWSBTN)
 VALUES (@v_grid_name,'UDF Field Layouts (AM)','WEBD','M','R5MENU','-','?','-','-','+','-','+','-','-','-','*','+','-','-','-','-','-','-','-','YN','-');

-------------------------------------------------------------------------------
-- Insert r5grid
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_grid_id OUTPUT, 'GRD', '1', @sChk OUTPUT
INSERT INTO R5GRID (GRD_DESC,GRD_GRIDID,GRD_BASEQUERY,GRD_GRIDNAME,GRD_BOTFUNCTION,GRD_PORTLETFLAG,GRD_TAB,GRD_GRIDTYPE,GRD_OPTIMIZERON,GRD_DISTINCT,GRD_COMPLEX,GRD_ACTIVE,GRD_NOSCREENDESIGNER)
 VALUES ('UDF Field Layouts (AM)',@v_grid_id,'FROM r5pagelayout p,r5functions f,r5boilertexts b,r5userdefinedfieldsetup udf
WHERE b.bot_lang = :parameter.language
AND f.fun_code = p.plo_pagename 
AND p.plo_pagename = b.bot_function
AND p.plo_pagename IN (''WSJOBS'', ''OSOBJA'',''OSOBJL'',''OSOBJP'', ''OSOBJS'')
AND p.plo_elementid = LOWER(b.bot_fld1)
AND p.plo_elementid LIKE ''udf%''
AND udf.udf_field = p.plo_elementid
AND (p.plo_elementtype = ''F''
AND p.plo_presentinjsp = ''Y'')
AND f.fun_rentity = udf.udf_rentity',@v_grid_name,@v_grid_name,'-','+',2,'-','-','-','+','-');

-------------------------------------------------------------------------------
-- Insert r5dddataspy
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_dataspy_id OUTPUT, 'DDS', '1', @sChk OUTPUT
INSERT INTO R5DDDATASPY (DDS_DDSPYNAME,DDS_DDSPYID,DDS_SCOPE,DDS_ORGANIZATION,DDS_CREATEDSTAMP,DDS_FILTERSTRXML,DDS_SORTSTRXML,DDS_OWNER,DDS_GRIDID,DDS_TYPE,DDS_DEFAULTFLAG,DDS_CLIENTROWS,DDS_BOTNAME,DDS_SECURITYDATASPY,DDS_MEKEY)
 VALUES ('All Records',@v_dataspy_id,'-','*',getdate(),'<FILTERABLE />','<SORTABLE />','R5',@v_grid_id,'SD','+',30,'DSNAME','-','YY');

-------------------------------------------------------------------------------
-- Insert the three base r5boilertexts
-- Note: You must also insert a r5boilertext record for each "grid field" (see below)
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,1,100,0,0,'$(languagecode)','List View','TB','1','LST','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,2,100,0,0,'$(languagecode)','WUDFLT','F','1','UDG_HDRLABEL','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,3,100,0,0,'$(languagecode)','All Records','F','1','DSNAME','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,4,100,0,0,'$(languagecode)','plo_usergroup','F','1','plo_usergroup','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,5,100,0,0,'$(languagecode)','plo_pagename','F','1','plo_pagename','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,6,100,0,0,'$(languagecode)','plo_elementid','F','1','plo_elementid','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,7,100,0,0,'$(languagecode)','plo_attribute','F','1','plo_attribute','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,8,100,0,0,'$(languagecode)','udf_field','F','1','udf_field','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,9,100,0,0,'$(languagecode)','udf_lookuptype','F','1','udf_lookuptype','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,10,100,0,0,'$(languagecode)','bot_text','F','1','bot_text','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,11,100,0,0,'$(languagecode)','plo_meflag','F','1','plo_meflag','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,12,100,0,0,'$(languagecode)','plo_tabindex','F','1','plo_tabindex','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,13,100,0,0,'$(languagecode)','udf_lookuprentity','F','1','udf_lookuprentity','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,14,100,0,0,'$(languagecode)','udf_uom','F','1','udf_uom','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,15,100,0,0,'$(languagecode)','udf_datetype','F','1','udf_datetype','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,16,100,0,0,'$(languagecode)','udf_numbertype','F','1','udf_numbertype','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,17,100,0,0,'$(languagecode)','fun_rentity','F','1','fun_rentity','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,18,100,0,0,'$(languagecode)','plo_fieldcontainer','F','1','plo_fieldcontainer','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,19,100,0,0,'$(languagecode)','plo_fieldgroup','F','1','plo_fieldgroup','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,20,100,0,0,'$(languagecode)','udf_min','F','1','udf_min','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,21,100,0,0,'$(languagecode)','udf_max','F','1','udf_max','10000',getdate(),'-');

-------------------------------------------------------------------------------
-- Copy the R5BOILERTEXTS for each of the languages in the R5LANGINST
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED)
SELECT BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,LIN_CODE,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED
FROM R5BOILERTEXTS, R5LANGINST
WHERE
BOT_LANG = '$(languagecode)' AND BOT_FUNCTION = @v_grid_name AND lin_code <> '$(languagecode)'

-------------------------------------------------------------------------------
-- Insert r5ddfield, r5gridfield, r5queryfield for each grid field
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_usergroup','VARCHAR','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,4,'TEXT','plo_usergroup','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',1,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_pagename','VARCHAR','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,5,'TEXT','plo_pagename','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',2,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_elementid','VARCHAR','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,6,'TEXT','plo_elementid','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',3,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_attribute','VARCHAR','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,7,'TEXT','plo_attribute','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',4,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
set @v_grid_key_fields =  LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_field','VARCHAR','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,8,'TEXT','udf_field','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',5,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_lookuptype','VARCHAR','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,9,'TEXT','udf_lookuptype','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',6,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'bot_text','VARCHAR','R5BOILERTEXTS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,10,'TEXT','bot_text','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',7,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_meflag','VARCHAR','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,11,'TEXT','plo_meflag','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',8,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_tabindex','NUMBER','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,12,'TEXT','plo_tabindex','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',9,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_lookuprentity','VARCHAR','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,13,'TEXT','udf_lookuprentity','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',10,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_uom','VARCHAR','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,14,'TEXT','udf_uom','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',11,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_datetype','VARCHAR','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,15,'TEXT','udf_datetype','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',12,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_numbertype','VARCHAR','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,16,'TEXT','udf_numbertype','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',13,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'fun_rentity','VARCHAR','R5FUNCTIONS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,17,'TEXT','fun_rentity','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',14,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_fieldcontainer','VARCHAR','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,18,'TEXT','plo_fieldcontainer','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',15,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'plo_fieldgroup','NUMBER','R5PAGELAYOUT');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,19,'TEXT','plo_fieldgroup','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',16,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_min','NUMBER','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,20,'TEXT','udf_min','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',17,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'udf_max','NUMBER','R5USERDEFINEDFIELDSETUP');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,21,'TEXT','udf_max','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',18,'LIST');


-------------------------------------------------------------------------------
-- Insert r5gridparam
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-- Setup field keys on r5grid
-------------------------------------------------------------------------------

update r5grid set 
grd_keyfields = @v_grid_key_fields, 
grd_filterablelist = @v_field_id_list,
grd_sortablelist = @v_field_id_list,
grd_displayablelist = @v_field_id_list
where grd_gridid = @v_grid_id;
